PHTTPServer Class Reference

A TCP/IP socket for the HyperText Transfer Protocol version 1.0. More...

`#include <http.h>`

Inheritance diagram for PHTTPServer:

## Public Member Functions

| PHTTPServer ()
| Create a TCP/IP HTTP protocol socket channel. More...
| PHTTPServer (const PHTTPSpace &urlSpace)
virtual PString | GetServerName () const
| Get the name of the server. More...
PHTTPSpace & | GetURLSpace ()
| Get the name space being used by the HTTP server socket. More...
void | SetURLSpace (const PHTTPSpace &space)
| Use a new URL name space for this HTTP socket. More...
virtual PBoolean | ProcessCommand ()
| Process commands, dispatching to the appropriate virtual function. More...
virtual PBoolean | OnGET (const PURL &url, const PMIMEInfo &info, const PHTTPConnectionInfo &conInfo)
| Handle a GET command from a client. More...
virtual PBoolean | OnHEAD (const PURL &url, const PMIMEInfo &info, const PHTTPConnectionInfo &conInfo)
| Handle a HEAD command from a client. More...
virtual PBoolean | OnPOST (const PURL &url, const PMIMEInfo &info, const PStringToString &data, const PHTTPConnectionInfo &conInfo)
| Handle a POST command from a client. More...
virtual PBoolean | OnProxy (const PHTTPConnectionInfo &conInfo)
| Handle a proxy command request from a client. More...
virtual PString | ReadEntityBody ()
| Read the entity body associated with a HTTP request, and close the socket if not a persistent connection. More...
virtual PBoolean | OnUnknown (const PCaselessString &command, const PHTTPConnectionInfo &connectInfo)
| Handle an unknown command. More...
PBoolean | StartResponse (StatusCode code, PMIMEInfo &headers, long bodySize)
| Write a command reply back to the client, and construct some of the outgoing MIME fields. More...
virtual PBoolean | OnError (StatusCode code, const PCaselessString &extra, const PHTTPConnectionInfo &connectInfo)
| Write an error response for the specified code. More...
void | SetDefaultMIMEInfo (PMIMEInfo &info, const PHTTPConnectionInfo &connectInfo)
| Set the default mime info. More...
PHTTPConnectionInfo & | GetConnectionInfo ()
| Get the connection info for this connection. More...
Public Member Functions inherited from PInternetProtocol
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
void | SetReadLineTimeout (const PTimeInterval &t)
| Set the maximum timeout between characters within a line. More...
virtual PBoolean | Connect (const PString &address, WORD port=0)
| Connect a socket to a remote host for the internet protocol. More...
virtual PBoolean | Connect (const PString &address, const PString &service)
virtual PBoolean | Accept (PSocket &listener)
| Accept a server socket to a remote host for the internet protocol. More...
const PString & | GetDefaultService () const
| Get the default service name or port number to use in socket connections. More...
PIPSocket * | GetSocket () const
| Get the eventual socket for the series of indirect channels that may be between the current protocol and the actual I/O channel. More...
virtual PBoolean | WriteLine (const PString &line)
| Write a string to the socket channel followed by a CR/LF pair. More...
virtual PBoolean | ReadLine (PString &line, PBoolean allowContinuation=false)
| Read a string from the socket channel up to a CR/LF pair. More...
virtual void | UnRead (int ch)
| Put back the characters into the data stream so that the next Read() function call will return them first. More...
virtual void | UnRead (const PString &str)
virtual void | UnRead (const void *buffer, PINDEX len)
virtual PBoolean | WriteCommand (PINDEX cmdNumber)
| Write a single line for a command. More...
virtual PBoolean | WriteCommand (PINDEX cmdNumber, const PString &param)
virtual PBoolean | ReadCommand (PINDEX &num, PString &args)
| Read a single line of a command which ends with a CR/LF pair. More...
virtual PBoolean | WriteResponse (unsigned numericCode, const PString &info)
| Write a response code followed by a text string describing the response to a command. More...
virtual PBoolean | WriteResponse (const PString &code, const PString &info)
virtual PBoolean | ReadResponse ()
| Read a response code followed by a text string describing the response to a command. More...
virtual PBoolean | ReadResponse (int &code, PString &info)
virtual int | ExecuteCommand (PINDEX cmdNumber)
| Write a command to the socket, using `WriteCommand()` and await a response using `ReadResponse()`. More...
virtual int | ExecuteCommand (PINDEX cmdNumber, const PString &param)
int | GetLastResponseCode () const
| Return the code associated with the last response received by the socket. More...
PString | GetLastResponseInfo () const
| Return the last response received by the socket. More...
Public Member Functions inherited from PIndirectChannel
| PIndirectChannel ()
| Create a new indirect channel without any channels to redirect to. More...
| ~PIndirectChannel ()
| Close the indirect channel, deleting read/write channels if desired. More...
Comparison | Compare (const PObject &obj) const
| Determine if the two objects refer to the same indirect channel. More...
virtual PString | GetName () const
| Get the name of the channel. More...
virtual PBoolean | Close ()
| Close the channel. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open and read and write operations can be executed on it. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual PChannel * | GetBaseReadChannel () const
| This function returns the eventual base channel for reading of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PChannel * | GetBaseWriteChannel () const
| This function returns the eventual base channel for writing of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
PBoolean | Open (PChannel &channel)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *channel, PBoolean autoDelete=true)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *readChannel, PChannel *writeChannel, PBoolean autoDeleteRead=true, PBoolean autoDeleteWrite=true)
| Set the channel for both read and write operations. More...
PChannel * | GetReadChannel () const
| Get the channel used for read operations. More...
bool | SetReadChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
PChannel * | GetWriteChannel () const
| Get the channel used for write operations. More...
PBoolean | SetWriteChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

void | Construct ()
Protected Member Functions inherited from PHTTP
| PHTTP ()
| Create a TCP/IP HTTP protocol channel. More...
virtual PINDEX | ParseResponse (const PString &line)
| Parse a response line string into a response code and any extra info on the line. More...
Protected Member Functions inherited from PInternetProtocol
| PInternetProtocol (const char *defaultServiceName, PINDEX cmdCount, char const *const *cmdNames)
Protected Member Functions inherited from PIndirectChannel
virtual PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PHTTPSpace | urlSpace
PHTTPConnectionInfo | connectInfo
unsigned | transactionCount
PTimeInterval | nextTimeout
Protected Attributes inherited from PInternetProtocol
PString | defaultServiceName
PStringArray | commandNames
PCharArray | unReadBuffer
PINDEX | unReadCount
PTimeInterval | readLineTimeout
enum PInternetProtocol::StuffState | stuffingState
PBoolean | newLineToCRLF
int | lastResponseCode
PString | lastResponseInfo
Protected Attributes inherited from PIndirectChannel
PChannel * | readChannel
| Channel for read operations. More...
PBoolean | readAutoDelete
| Automatically delete read channel on destruction. More...
PChannel * | writeChannel
| Channel for write operations. More...
PBoolean | writeAutoDelete
| Automatically delete write channel on destruction. More...
PReadWriteMutex | channelPointerMutex
| Race condition prevention on closing channel. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Additional Inherited Members

Public Types inherited from PHTTP
enum | Commands { GET, HEAD, POST, PUT, DELETE, TRACE, OPTIONS, CONNECT, NumCommands }

enum

StatusCode {
Continue = 100, SwitchingProtocols, RequestOK = 200, Created,
Accepted, NonAuthoritativeInformation, NoContent, ResetContent,
PartialContent, MultipleChoices = 300, MovedPermanently, MovedTemporarily,
SeeOther, NotModified, UseProxy, BadRequest = 400,
UnAuthorised, PaymentRequired, Forbidden, NotFound,
MethodNotAllowed, NoneAcceptable, ProxyAuthenticationRequired, RequestTimeout,
Conflict, Gone, LengthRequired, UnlessTrue,
InternalServerError = 500, NotImplemented, BadGateway, ServiceUnavailable,
GatewayTimeout
}

Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PHTTP
static const PCaselessString & | AllowTag ()
static const PCaselessString & | AuthorizationTag ()
static const PCaselessString & | ContentEncodingTag ()
static const PCaselessString & | ContentLengthTag ()
static const PCaselessString & | ContentTypeTag ()
static const PCaselessString & | DateTag ()
static const PCaselessString & | ExpiresTag ()
static const PCaselessString & | FromTag ()
static const PCaselessString & | IfModifiedSinceTag ()
static const PCaselessString & | LastModifiedTag ()
static const PCaselessString & | LocationTag ()
static const PCaselessString & | PragmaTag ()
static const PCaselessString & | PragmaNoCacheTag ()
static const PCaselessString & | RefererTag ()
static const PCaselessString & | ServerTag ()
static const PCaselessString & | UserAgentTag ()
static const PCaselessString & | WWWAuthenticateTag ()
static const PCaselessString & | MIMEVersionTag ()
static const PCaselessString & | ConnectionTag ()
static const PCaselessString & | KeepAliveTag ()
static const PCaselessString & | TransferEncodingTag ()
static const PCaselessString & | ChunkedTag ()
static const PCaselessString & | ProxyConnectionTag ()
static const PCaselessString & | ProxyAuthorizationTag ()
static const PCaselessString & | ProxyAuthenticateTag ()
static const PCaselessString & | ForwardedTag ()
static const PCaselessString & | SetCookieTag ()
static const PCaselessString & | CookieTag ()
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
Protected Types inherited from PInternetProtocol
enum | StuffState { DontStuff, StuffIdle, StuffCR, StuffCRLF, StuffCRLFdot, StuffCRLFdotCR }

## Detailed Description

A TCP/IP socket for the HyperText Transfer Protocol version 1.0.

The server socket thread would continuously call the ProcessCommand() function until it returns false. This will then call the appropriate virtual function on parsing the HTTP protocol.

    PTCPSocket socket(80);
    if (!socket.Listen())
      return;

    PHTTPSpace httpNameSpace;
    httpNameSpace.AddResource(new PHTTPDirectory("data", "data"))

    PHTTServer httpServer(httpNameSpace);
    if (!httpServer.Open(socket))
      return;

    while (httpServer.ProcessCommand())
      ;

## Constructor & Destructor Documentation

PHTTPServer::PHTTPServer | ( |  | ) |

Create a TCP/IP HTTP protocol socket channel.

The form with the single `port` parameter creates an unopened socket, the form with the `address` parameter makes a connection to a remote system, opening the socket. The form with the `socket` parameter opens the socket to an incoming call from a "listening" socket.

PHTTPServer::PHTTPServer | ( | const PHTTPSpace & | urlSpace | ) |

Parameters

  urlSpace | Name space to use for URLs received.

## Member Function Documentation

void PHTTPServer::Construct | ( |  | ) |

protected

PHTTPConnectionInfo& PHTTPServer::GetConnectionInfo | ( |  | ) |

inline

Get the connection info for this connection.

References connectInfo.

virtual PString PHTTPServer::GetServerName | ( |  | ) | const

virtual

Get the name of the server.

Returns
  String name of the server.

PHTTPSpace& PHTTPServer::GetURLSpace | ( |  | ) |

inline

Get the name space being used by the HTTP server socket.

Returns
  URL name space tree.

References urlSpace.

virtual PBoolean PHTTPServer::OnError | ( | StatusCode | code,
|  | const PCaselessString & | extra,
|  | const PHTTPConnectionInfo & | connectInfo
| ) |  |

virtual

Write an error response for the specified code.

Depending on the `code` parameter this function will also send a HTML version of the status code for display on the remote client viewer.

Returns
  true if the connection may persist, false if the connection must close

Parameters

  code | Status code for the error response.
  extra | Extra information included in the response.
  connectInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnGET | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | conInfo
| ) |  |

virtual

Handle a GET command from a client.

The default implementation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnHEAD | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | conInfo
| ) |  |

virtual

Handle a HEAD command from a client.

The default implemetation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnPOST | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PStringToString & | data,
|  | const PHTTPConnectionInfo & | conInfo
| ) |  |

virtual

Handle a POST command from a client.

The default implementation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  data | Variables provided in the POST data.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnProxy | ( | const PHTTPConnectionInfo & | conInfo | ) |

virtual

Handle a proxy command request from a client.

This will only get called if the request was not for this particular server. If it was a proxy request for this server (host and port number) then the appropriate `OnGET()`, `OnHEAD()` or `OnPOST()` command is called.

The default implementation returns OnError(BadGateway).

Returns
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters

  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnUnknown | ( | const PCaselessString & | command,
|  | const PHTTPConnectionInfo & | connectInfo
| ) |  |

virtual

Handle an unknown command.

Returns
  true if the connection may persist, false if the connection must close

Parameters

  command | Complete command line received.
  connectInfo | HTTP connection information

virtual PBoolean PHTTPServer::ProcessCommand | ( |  | ) |

virtual

Process commands, dispatching to the appropriate virtual function.

This is used when the socket is acting as a server.

Returns
  true if the request specified persistent mode and the request version allows it, false if the socket closed, timed out, the protocol does not allow persistent mode, or the client did not request it timed out

virtual PString PHTTPServer::ReadEntityBody | ( |  | ) |

virtual

Read the entity body associated with a HTTP request, and close the socket if not a persistent connection.

Returns
  The entity body of the command

void PHTTPServer::SetDefaultMIMEInfo | ( | PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | connectInfo
| ) |  |

Set the default mime info.

Parameters

  info | Extra MIME information in command.
  connectInfo | Connection information

void PHTTPServer::SetURLSpace | ( | const PHTTPSpace & | space | ) |

Use a new URL name space for this HTTP socket.

Parameters

  space | New URL name space to use.

PBoolean PHTTPServer::StartResponse | ( | StatusCode | code,
|  | PMIMEInfo & | headers,
|  | long | bodySize
| ) |  |

Write a command reply back to the client, and construct some of the outgoing MIME fields.

The MIME fields are not sent.

The `bodySize` parameter determines the size of the entity body associated with the response. If `bodySize` is >= 0, then a ContentLength field will be added to the outgoing MIME headers if one does not already exist.

If `bodySize` is < 0, then it is assumed that the size of the entity body is unknown, or has already been added, and no ContentLength field will be constructed.

If the version of the request is less than 1.0, then this function does nothing.

Returns
  true if requires v1.1 chunked transfer encoding.

Parameters

  code | Status code for the response.
  headers | MIME variables included in response.
  bodySize | Size of the rest of the response.

## Member Data Documentation

PHTTPConnectionInfo PHTTPServer::connectInfo

protected

Referenced by GetConnectionInfo().

PTimeInterval PHTTPServer::nextTimeout

protected

unsigned PHTTPServer::transactionCount

protected

PHTTPSpace PHTTPServer::urlSpace

protected

Referenced by GetURLSpace().

The documentation for this class was generated from the following file:

- http.h